#!/usr/bin/perl

BEGIN {
	require "fatlib.pl";
};

use utf8;
use strict;

# "1.150n"-"1.199n"
my $VER="V.1.160n(nanakochi123456)";
my $tarball="power110714.tar.gz";
my $data_update=<<EOM;
<li>2011/7/08 17:48 エリアの群馬・神奈川が更新されました。</li>
<li>2011/6/21 14:49 節電事例に色々追記してあります。</li>
<li>2011/6/21 19:02 ９月３０日までのデータを入力した。</li>
<li>2011/6/21 06:21 東京電力でんき予報速報へのリンクをした。</li>
<li>2011/6/19 09:30 東京電力の6月20日以降のグループに切り替えをした。</li>
<li>2011/6/16 20:15 節電の心得に鉄道を追加した。</li>
<li>2011/6/13 18:55 食事による節電事例を追加した。</li>
<li>2011/6/11 05:05 東京電力のタイムテーブルの２回目の括弧付けをやめ、表示しないようにした。</li>
<li>2011/6/07 05:40 東京電力のタイムテーブルが、やむを得ず計画停電を実施する場合の予定表の２回目が実行されないようなので括弧付けにした。</li>
<li>2011/6/05 17:00 節電の心得がTOPに出るように変更 (PC版のみ)、その他節電の心得の追記、情報ソース元を記載</li>
<li>2011/6/01 06:00 節電の心得一部変更</li>
<li>2011/5/29 19:30 データ更新ではないが、「世界中から日本へ送る応援メッセージ」への動画のリンクをした(PCのみ)</li>
<li>2011/5/24 07:30 節電の心得のエアコンについて追記</li>
<li>2011/5/24 07:30 節電の心得をテレビ、パソコンを分離した。</li>
<li>2011/5/24 19:15 他の節電ソフトも紹介しました。</li>
<li>2011/5/24 19:02 Microsoftの節電策に、節電の心得の中にリンクした</li>
<li>2011/5/24 17:43 電力売り上げ実績サイトへリンクした(PC向けのみ)</li>
<li>2011/5/24 15:23 節電事例に、更に予算がある方へのソーラーパネル設置による売電、及び屋上緑化における節電ケースを掲載した</li>
<li>2011/5/23 02:45 6月30日分までのテーブルを追記した。</li>
<li>2011/5/23 01:23 東京電力より新たな具体的な節電事例が追加されたため追記した</li>
EOM

my $engine_update=<<EOM;
<li>2011/7/14 19:35 中部電力のでんき予報に対応した。</li>
<li>2011/7/14 18:30 東北電力のでんき予報に対応した。</li>
<li>2011/7/08 13:15 IE9対策のために、Twitterのハッシュタグをプロクシ動作をさせた。</li>
<li>2011/7/08 04:11 Twitterのポストに、過去に使用していた。#jishin_power ハッシュタグを追加した。</li>
<li>2011/7/07 07:57 直接は関係ありませんが、Twitterによる関西電力、東北電力の使用率お知らせに対応した。</li>
<li>2011/7/06 12:00 一部ブラウザで言語設定により英語表示になってしまうのを修正した。また、マスタサイトのみIPV6に試験対応をした。</li>
<li>2011/7/05 09:00 東京電力の使用量で、当日以外の色を変更した。</li>
<li>2011/7/04 12:30 関西電力の使用量一覧を追加した。</li>
<li>2011/7/04 02:06 東京電力のでんき予報をの結果を、任意の日付で閲覧できるようにした。(PCのみ)</li>
<li>2011/7/02 05:00 東京電力のでんき予報の昨日のデータ閲覧、及び、過去３年間のデータ（同日）を閲覧できるようにした。(PCのみ)また、使用率に応じて色を変更するようにした。(PCのみ)</li>
<li>2011/7/01 03:00 東京電力のでんき予報に対応。11:32追記：ダウンロードファイル名が誤っていたのを修正。</li>
<li>2011/6/30 19:29 東京電力電力使用率グラフのCSVデータを一時的に旧フォーマットで提供されているものに一時変更した。</li>
<li>2011/6/24 19:56 TOPページにおけるSEO対策が不十分であることが確かめられたので変更した。</li>
<li>2011/6/22 13:43 電力使用状況予想時間が更新されることがあるので、更新時刻を表記した。また、パーセントで表記するようにした。</li>
<li>2011/6/21 19:02 東京電力、東北電力共に、公式のグラフサイトにリンクをした（東北電力英語を除く）</li>
<li>2011/6/16 21:08 東北電力の使用状況を見れるようにした。</li>
<li>2011/6/15 13:15 当日と前日の差が0万kwの時に差が表示されないのを修正した</li>
<li>2011/6/11 05:05 ↓キャッシュ制御を改めて修正した</li>
<li>2011/6/10 17:45 ↓キャッシュ制御にバグがあった為修正</li>
<li>2011/6/10 15:45 東京電力の使用状況をPC、及びモバイル、及び英語で見れるようにした。</li>
<li>2011/6/10 07:12 東京電力の使用状況を現状PCのみで見れるようにした。いずれ英語、携帯、RSS出力に対応します。</li>
<li>2011/4/23 16:12 一部のモバイル「開発環境」において、それなりの判定を出来なかったのを修正</li>
<li>2011/4/06 10:49 モバイル向けのHTML出力をわずかに変更した</li>
<li>2011/4/05 19:15 町名を入力しない場合、グループの計画停電時間の一覧を表示するようにした。</li>
<li>2011/4/03 18:00 サブグループを含めた検索を再検証し、実装しなおした。また、area.html、及び area.xml 化をした。</li>
<li>2011/4/02 11:01 サブグループも含めた検索を実装した。携帯の出力を変更した。</li>
EOM

#------------
use Encode;
use CGI;
use HTTP::Lite;

require "common.pl";

$VER=~s/\(.*//g;

if($ENV{QUERY_STRING} eq "kepco" || $ENV{QUERY_STRING} eq "tohoku" || $ENV{QUERY_STRING} eq "cepco") {
	print <<EOM;
Content-type: text/plain

EOM
	$ENV{QUERY_STRING}=~s/\/\.//g;
	if(open(R,"cache/$ENV{QUERY_STRING}.twitter")) {
		my $buf;
		foreach(<R>) {
			$buf.=$_;
		}
		Encode::from_to($buf, "utf8", "shiftjis" );
		print $buf;
		close(R);
	}
	exit;
}

if($ENV{QUERY_STRING}=~/cmd\=twitter\_proxy/) {
	&twitter_proxy;
	exit;
}

my $nojapaneseflg=0;
$nojapaneseflg=1 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/en/);
$nojapaneseflg=0 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/ja/);
my $mobileflg=0;
$mobileflg=1 if($ENV{HTTP_USER_AGENT}=~/DoCoMo|UP\.Browser|KDDI|SoftBank|Voda[F|f]one|J\-PHONE|DDIPOCKET|WILLCOM|iPod|PDA|Mobile|Semulator/);

$mobileflg=0 if($ENV{QUERY_STRING}=~'p');
$mobileflg=1 if($ENV{QUERY_STRING}=~'m');
$nojapaneseflg=0 if($ENV{QUERY_STRING}=~'j');
$nojapaneseflg=1 if($ENV{QUERY_STRING}=~'e');

my $english_file="english.html";
my $english_mobile_file="english_mobile.html";
my $mobile_file="mobile.html";
my $pc_file="pc.html";
my $mobile_update_file="mobile_update.html";
my $mobile_setuden_file="mobile_setuden.html";

&gzip_compress("Content-type: text/html; charset=utf-8");
my $body;
my $file;
my $kanaflg=0;
my $updatetitle;
if($nojapaneseflg) {
	if($mobileflg) {
		$file=$english_mobile_file;
	} else {
		$file=$english_file;
	}
} elsif($ENV{QUERY_STRING}=~/^mju/) {
	$file=$mobile_update_file;
	$kanaflg=1;
} elsif($ENV{QUERY_STRING}=~/^mjs/) {
	$file=$mobile_setuden_file;
	$kanaflg=1;
} elsif($mobileflg) {
	$file=$mobile_file;
	$kanaflg=1;
} else {
	$file=$pc_file;
}

if(open(R,"<:utf8","$file")) {
	foreach(<R>) {
		if(/\@\@/) {
			s/\@\@VER\@\@/$VER/;
			s/\@\@INCLUDE\=\"(.+)\"\@\@/@{[&include($1)]}/;
			s/\@\@QRCODEEN\@\@/@{[&qrcode_link_en]}/;
			s/\@\@QRCODEJP\@\@/@{[&qrcode_link]}/;
			s/\@\@DATAUPDATE\@\@/$data_update/;
			s/\@\@ENGINEUPDATE\@\@/$engine_update/;
			s/\@\@TARBALL\@\@/$tarball/;
		}
		$body.=$_;
	}
	close(R);
} else {
	$body="$file not found. sorry.";
}
if($kanaflg) {
	$body=&z2h($body);
}
binmode(STDOUT, ":utf8");
print "$body\n";
close(STDOUT);
exit;

sub include {
	my $file=shift;
	my $body="";
	if(open(I,"<:utf8","$file")) {
		my $div=$file;
		$div=~s/\.//g;
		$body.=<<EOM;
<div id="$div">
EOM
		foreach(<I>) {
			$body.=$_;
		}
		close(I);
		$body.="</div>\n";
	}
	$body;
}

sub qrcode_link {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath");
	if(&load_module("GD") && &load_module("GD::Barcode")) {
		return <<FIN;
携帯へURLを送るには、こちらのQRコードをご利用下さい。<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub qrcode_link_en {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath?e");
	if(&load_module("GD::Barcode")) {
		return <<FIN;
If you have mobile phone to transfer this site, use this barcode.
<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub twitter_proxy {
	my $query=new CGI;
	my $rpp=$query->param('rpp');
	my $q=&enc($query->param('q'));
	my $near=$query->param('near');
	my $within=$query->param('widhin');
	my $units=$query->param('units');
	my $since_id=$query->param('since_id');
	my $callback=$query->param('callback');

	my $searchurl="http://search.twitter.com/search.json";
	$searchurl.="?rpp=$rpp&callback=$callback&q=$q";
	my ($status,$stream)=&httpcl($searchurl);

	if($status eq 0) {
		&gzip_compress("Content-type: application/json");
		print $stream;
	} else {
		print "Content-type: text/plain\n\n";
		print "Cant get '$searchurl'\n";
	}
	exit;
}
